=== debian/changelog ===
onevpl-intel-gpu (23.2.3-1) unstable; urgency=medium

  * New upstream release.
  * patches: Drop upstreamed patch.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 19 Jun 2023 16:38:15 +0300
